VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Tile tutorial"
   ClientHeight    =   6735
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8955
   LinkTopic       =   "Form1"
   ScaleHeight     =   449
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   597
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox chkWalkable 
      Caption         =   "Walkable"
      Height          =   195
      Left            =   720
      TabIndex        =   10
      Top             =   5220
      Width           =   1335
   End
   Begin VB.CommandButton cmdAddTile 
      Caption         =   "Add tile"
      Height          =   435
      Left            =   720
      TabIndex        =   9
      Top             =   5520
      Width           =   1335
   End
   Begin VB.TextBox txtTile 
      Alignment       =   2  'Zentriert
      Height          =   285
      Left            =   720
      TabIndex        =   8
      Text            =   ".bmp"
      Top             =   4860
      Width           =   1335
   End
   Begin VB.ComboBox lstMode 
      Height          =   315
      ItemData        =   "frmMain.frx":0000
      Left            =   6900
      List            =   "frmMain.frx":000A
      Style           =   2  'Dropdown-Liste
      TabIndex        =   7
      Top             =   5940
      Width           =   1215
   End
   Begin VB.ComboBox lstTiles 
      Height          =   315
      Left            =   4080
      Style           =   2  'Dropdown-Liste
      TabIndex        =   5
      Top             =   5940
      Width           =   1995
   End
   Begin VB.CommandButton cmdClearMap 
      Caption         =   "Clear map"
      Height          =   435
      Left            =   720
      TabIndex        =   4
      Top             =   1440
      Width           =   1335
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save map"
      Height          =   435
      Left            =   720
      TabIndex        =   3
      Top             =   960
      Width           =   1335
   End
   Begin VB.PictureBox Front 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   4860
      Left            =   3240
      ScaleHeight     =   320
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   320
      TabIndex        =   0
      Top             =   960
      Width           =   4860
   End
   Begin VB.Label lblInfo 
      Caption         =   "on layer"
      Height          =   255
      Index           =   3
      Left            =   6180
      TabIndex        =   11
      Top             =   6000
      Width           =   675
   End
   Begin VB.Label lblInfo 
      Caption         =   "Paint tile"
      Height          =   255
      Index           =   1
      Left            =   3240
      TabIndex        =   6
      Top             =   6000
      Width           =   735
   End
   Begin VB.Label lblInfo 
      Caption         =   "Controls"
      Height          =   255
      Index           =   2
      Left            =   480
      TabIndex        =   2
      Top             =   540
      Width           =   2475
   End
   Begin VB.Label lblInfo 
      Caption         =   "Use left button to draw, right button to drag camera"
      Height          =   315
      Index           =   0
      Left            =   3240
      TabIndex        =   1
      Top             =   540
      Width           =   4875
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Used for camera movement
    Dim X2 As Long
    Dim Y2 As Long
Private Sub LoadTilesList()
    Dim A As Long
    
    'Reset list box
    lstTiles.Clear
    lstTiles.AddItem "(none)"
    
    'Load list
    For A = 1 To TileCount: lstTiles.AddItem Tile(A).PictureFile: Next
    
    'Select first item
    lstTiles.ListIndex = 0
    lstMode.ListIndex = 0
End Sub

Public Sub Main()
    Me.Show
    
    'This is the "main loop"
    While DoEvents
        'Update animations
        mTiles.Animate
        
        'Update display
        Redraw
    Wend
End Sub

Public Sub Redraw()
    'Draw
    mMap.DrawFloor
    'Draw actors here
    mMap.DrawRoof
    
    'Update ("flip") display
    Front.Refresh
End Sub

Private Sub cmdAddTile_Click()
    'Add new tile
    AddTile txtTile.Text, (chkWalkable.Value = 1)
    
    'Update tiles list
    lstTiles.AddItem Tile(TileCount).PictureFile
    
    'Reload resources
    mTiles.LoadResources
End Sub


Private Sub cmdClearMap_Click()
    Dim A As Long
    
    With Map
        'Set new size
        .w = 64
        .h = 64
        
        'Resize memory
        ReDim .Floor(.w * .h)
        ReDim .Roof(.w * .h)
        
        'Fill grass
        For A = 0 To (.w * .h)
            .Floor(A) = 1
        Next
    End With
End Sub

Private Sub cmdSave_Click()
    'Call save function
    mMap.SaveData App.Path & "\Test.map"
End Sub

Private Sub Form_Load()
    'Initialize modules
    mBitmap.Initialize frmMain
    mMap.Reset
    mTiles.Reset
    mCamera.Reset frmMain.Front
    
    'Load map and resources
    mMap.LoadData App.Path & "\Test.map"
    mTiles.LoadResources
    
    LoadTilesList
    
    'Run game
    Main
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Release modules
    mTiles.Reset
    mMap.Reset
    mBitmap.Reset
End Sub

Private Sub Front_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
On Error Resume Next 'Never let edit functions crash your program

    Dim TempX As Long
    Dim TempY As Long
    Dim Index As Long
    Dim TileIndex As Long
    
    Select Case Button
    Case 1 'Left button
        'Get mouse position in tiles
        TempX = CLng((x - (TileSize / 2) + Camera.x) / TileSize)
        TempY = CLng((y - (TileSize / 2) + Camera.y) / TileSize)
        '(subtract the half TileSize to get the middle of the tile)
        
        'Check position
        If TempX < 0 Then: Exit Sub
        If TempY < 0 Then: Exit Sub
        If TempX >= Map.w Then: Exit Sub
        If TempY >= Map.h Then: Exit Sub
        
        'Get selected tile index
        TileIndex = lstTiles.ListIndex
        
        'Set tile there
        Select Case lstMode.ListIndex
        Case 0 'Floor
            SetFloorTile TempX, TempY, TileIndex
        Case 1 'Roof
            SetRoofTile TempX, TempY, TileIndex
        End Select
    
    Case 2 'Right button
        X2 = CLng(x)
        Y2 = CLng(y)
    End Select
End Sub
Private Sub Front_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Select Case Button
    Case 1: 'Left button
        'Forward event when painting tiles
        Front_MouseDown Button, Shift, x, y
    
    Case 2: 'Right button
        'Drag camera
        mCamera.LookAt Camera.x + CLng(x) - X2, Camera.y + CLng(y) - Y2
        
        'Store new cursor position
        X2 = x
        Y2 = y
    End Select
End Sub


